import config as cf

from gurobipy import *
import numpy as np

def result_f(Z, mu, d, b, q, V, scenarios, arrivals, p_nodes, n_ins, test):
    obj = Z.objVal
    rt = Z.Runtime
    
    if cf.model_type == 'exp':
        obj_sc = [float(-cf.wt[0]*mu[sc].x+cf.wt[1]*sum(d[v,sc].x 
                                                        for v in V)
                        ) 
                  for sc in scenarios]
    
    else:
        obj_sc = [None for sc in scenarios]
    
    opt_gap = Z.MIPGap
    evac = np.array([[float(mu[sc].x),float(np.array(arrivals[sc]).sum())] 
                     for sc in scenarios])
    evac = evac.astype('float64')

    percent_evac = np.divide(evac[:,0],evac[:,1],dtype='float64')

    total_dist_traveled = np.array([sum(float(d[v,sc].x) for v in V) 
                                    for sc in scenarios])
    budget = [b[sc].x for sc in scenarios]
    
    if type(test) == int:
        loc_evac = {i: 0 for i in cf.pickup[n_ins]}
        for i in cf.pickup[n_ins]:
            for t in range(cf.T+1):
                if (i,t) in p_nodes:
                    for v in V:
                        loc_evac[i]+=q[v,i,t,0].x
        loc_demand = {i: np.array([arrivals[0][i][t] 
                                   for t in range(cf.T+1)]).sum() 
                      for i in cf.pickup[n_ins]}
    
    else:
        loc_evac = None
        loc_demand = None
    
    return (obj, rt, obj_sc, opt_gap, evac, percent_evac, 
            total_dist_traveled, budget, loc_evac, loc_demand)
