import config as cf
from make_folder import make_folder_f
from exp_model import exp_model_f
from cc_model import cc_model_f
from data_overview_columns import os_col_names_f

import pandas as pd
import numpy as np
import json

def initialize_f(num):
    array = np.array([num for sc in range(cf.noutofsample)])
    array = array.astype('float64')
    return array

def os_test_f(n_ins, hour, sample, exp_n_h_demand,
              s_hired_dict, s_dict, r_dict,
              G_o, origins, p_nodes, os_scen,
              w_n_folder, w_h_folder,
              n_data_overview):
    os_data = []
    
    result_types = {'obj', 'percent_evac', 'dist', 'time',
               'r_cars', 'evac', 's_leave', 'r_leave', 't_demand'}
    result = {}
    for typ in result_types:
        result[typ] = initialize_f(0.0)
    
    result['t_demand'] = initialize_f(1.0)

    for sc in range(cf.noutofsample):
        print('instance-', n_ins+1, 'hour-', hour+1, 'sample-', sample+1, 
              'out of sample', sc+1)
        if cf.os_test_type == 'exp':
            (result_scen,
             opt_gap_os, 
             obj_os_list, 
             budget_os, 
             s_hired_dict_os,
             r_hired_dict_os,
             veh_routing_dict, 
             loc_demand, loc_evac) = exp_model_f(sc, s_hired_dict, r_dict, 
                                                 G_o, p_nodes, [os_scen[sc]], 
                                                 [0], origins, n_ins)
        elif cf.os_test_type == 'cc':
            (k_os, 
             result_scen, 
             opt_gap_os,
             obj_os_list, 
             budget_os, 
             s_hired_dict_os,
             r_hired_dict_os,
             veh_routing_dict, 
             loc_demand, loc_evac) = cc_model_f(sc, s_hired_dict, r_dict, G_o, 
                                                p_nodes, [os_scen[sc]], 
                                                exp_n_h_demand, [0], origins, 
                                                n_ins)
        
        if cf.store_vehicle_routing_solns:
            w_v_folder = make_folder_f(w_h_folder, 'Out of Sample Vehicle Routing Solns')
            veh_routing_json = json.dumps(veh_routing_dict)  
            with open(''.join([w_v_folder,'Scenario ',str(sc+1),'.json']),'w+') as file:
                file.write(veh_routing_json)
                                      
        for typ in result_types:
            if type(result_scen[typ]) == list:
                result[typ][sc] = result_scen[typ][0]
            else:
                result[typ][sc] = result_scen[typ]
    
        result['obj'] = result['obj'].astype('float64')
        result['dist'] = result['dist'].astype('float64')

        single_scen_data_list = [sc+1, 
                                 result['obj'][sc],
                                 result['time'][sc],
                                 opt_gap_os,
                                 result['t_demand'][sc],
                                 result['evac'][sc],
                                 result['percent_evac'][sc],
                                 result['r_cars'][sc],
                                 r_hired_dict_os,
                                 result['dist'][sc],
                                 budget_os[0],
                                 result['s_leave'][sc],
                                 result['r_leave'][sc]]
    
    
        scenario_columns=['Scenario','Obj','Runtime','Opt Gap for Scen MIP',
                          'Total Demand','Total Evac','Percent Evac',
                          'Emergency Cars Hired', 'Emergency Cars Hired Dict',
                          'Dist','Budget','Planned Leave','Emer Leave']
        for i in cf.pickup[n_ins]:
            if loc_demand[i] == 0:
                loc_percent_evac = 0
            else:
                loc_array = np.array([loc_evac[i],loc_demand[i]])
                loc_array = loc_array.astype('float64')
                loc_percent_evac = np.divide(loc_array[0],loc_array[1])        
            single_scen_data_list.append(loc_evac[i])
            single_scen_data_list.append(loc_demand[i])
            single_scen_data_list.append(loc_percent_evac)
            scenario_columns.append(''.join(['Evac ',str(i)]))
            scenario_columns.append(''.join(['Demand ',str(i)]))
            scenario_columns.append(''.join(['Percent Demand Evac ',str(i)]))
        
        os_data.append(single_scen_data_list)
                        
        data_df = None
        data_df = pd.DataFrame(os_data,columns=scenario_columns)
        data_df.to_excel(''.join([w_h_folder,'Out of Sample Test ',
                                  str(sample+1),'.xls']))                
    
    # result['t_demand'] = result['t_demand'].astype('float64')
    # result['evac'] = result['evac'].astype('float64')
    # result['percent_evac']
    n_data_overview[n_ins][1].append([cf.n_names[n_ins],
                                      hour+1, 
                                      sample+1,
                                      result['time'].sum(),
                                      np.mean(result['obj']),
                                      np.max(result['obj']),
                                      np.mean(result['percent_evac']),
                                      np.var(result['percent_evac']),
                                      np.min(result['percent_evac']), 
                                      exp_n_h_demand,
                                      np.mean(result['t_demand']),
                                      np.var(result['t_demand']),
                                      np.mean(result['dist']),
                                      np.var(result['dist']),
                                      len(s_hired_dict.keys()),
                                      len(s_dict.keys()),
                                      np.mean(result['s_leave']),
                                      np.mean(result['r_cars']),
                                      len(r_dict.keys()),
                                      np.var(result['r_cars']),
                                      np.mean(result['r_leave']),
                                      s_hired_dict])
    data_df = None
    data_df = pd.DataFrame(n_data_overview[n_ins][1],columns=os_col_names_f())
    data_df.to_excel(''.join([w_n_folder,'Out of Sample Overview.xls']))
    
    return n_data_overview

